Index: include/avr/iom163.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom163.h,v
retrieving revision 1.20
diff -u -r1.20 iom163.h
--- include/avr/iom163.h	11 Feb 2009 17:53:35 -0000	1.20
+++ include/avr/iom163.h	26 Mar 2009 20:10:27 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -166,70 +167,87 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		3
 #define TIMER2_COMP_vect		_VECTOR(3)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(3)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			4
 #define TIMER2_OVF_vect			_VECTOR(4)
 #define SIG_OVERFLOW2			_VECTOR(4)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		5
 #define TIMER1_CAPT_vect		_VECTOR(5)
 #define SIG_INPUT_CAPTURE1		_VECTOR(5)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		6
 #define TIMER1_COMPA_vect		_VECTOR(6)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		7
 #define TIMER1_COMPB_vect		_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(7)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			8
 #define TIMER1_OVF_vect			_VECTOR(8)
 #define SIG_OVERFLOW1			_VECTOR(8)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			9
 #define TIMER0_OVF_vect			_VECTOR(9)
 #define SIG_OVERFLOW0			_VECTOR(9)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			10
 #define SPI_STC_vect			_VECTOR(10)
 #define SIG_SPI				_VECTOR(10)
 
 /* UART, RX Complete */
+#define UART_RX_num 			11
 #define UART_RX_vect			_VECTOR(11)
 #define SIG_UART_RECV			_VECTOR(11)
 
 /* UART Data Register Empty */
+#define UART_UDRE_num 			12
 #define UART_UDRE_vect			_VECTOR(12)
 #define SIG_UART_DATA			_VECTOR(12)
 
 /* UART, TX Complete */
+#define UART_TX_num 			13
 #define UART_TX_vect			_VECTOR(13)
 #define SIG_UART_TRANS			_VECTOR(13)
 
 /* ADC Conversion Complete */
+#define ADC_num 			14
 #define ADC_vect			_VECTOR(14)
 #define SIG_ADC				_VECTOR(14)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			15
 #define EE_RDY_vect			_VECTOR(15)
 #define SIG_EEPROM_READY		_VECTOR(15)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			16
 #define ANA_COMP_vect			_VECTOR(16)
 #define SIG_COMPARATOR			_VECTOR(16)
 
 /* 2-Wire Serial Interface */
+#define TWI_num 			17
 #define TWI_vect			_VECTOR(17)
 #define SIG_2WIRE_SERIAL		_VECTOR(17)
 
@@ -636,4 +654,131 @@
 #define SIGNATURE_2 0x02
 
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	4
+
+#define DDR_ADc5  	DDRA
+#define PORT_ADc5 	PORTA
+#define PIN_ADc5  	PINA
+#define ADc5_IDX  	5
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRA
+#define PORT_ADC7 	PORTA
+#define PIN_ADC7  	PINA
+#define ADC7_IDX  	7
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCL  	DDRC
+#define PORT_SCL 	PORTC
+#define PIN_SCL  	PINC
+#define SCL_IDX  	0
+
+#define DDR_SDA  	DDRC
+#define PORT_SDA 	PORTC
+#define PIN_SDA  	PINC
+#define SDA_IDX  	1
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_OC1B  	DDRD
+#define PORT_OC1B 	PORTD
+#define PIN_OC1B  	PIND
+#define OC1B_IDX  	4
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_ICP  	DDRD
+#define PORT_ICP 	PORTD
+#define PIN_ICP  	PIND
+#define ICP_IDX  	6
+
+#define DDR_OC2  	DDRD
+#define PORT_OC2 	PORTD
+#define PIN_OC2  	PIND
+#define OC2_IDX  	7
+
+
 #endif /* _AVR_IOM163_H_ */
Index: include/avr/io8515.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io8515.h,v
retrieving revision 1.10
diff -u -r1.10 io8515.h
--- include/avr/io8515.h	13 Aug 2008 23:29:49 -0000	1.10
+++ include/avr/io8515.h	26 Mar 2009 20:10:21 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -177,50 +178,62 @@
 /* Interrupt vectors */
 
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Timer/Counter Capture Event */
+#define TIMER1_CAPT_num 		3
 #define TIMER1_CAPT_vect		_VECTOR(3)
 #define SIG_INPUT_CAPTURE1		_VECTOR(3)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		4
 #define TIMER1_COMPA_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(4)
 
 /* Timer/Counter1 Compare MatchB */
+#define TIMER1_COMPB_num 		5
 #define TIMER1_COMPB_vect		_VECTOR(5)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(5)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			6
 #define TIMER1_OVF_vect			_VECTOR(6)
 #define SIG_OVERFLOW1			_VECTOR(6)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			7
 #define TIMER0_OVF_vect			_VECTOR(7)
 #define SIG_OVERFLOW0			_VECTOR(7)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			8
 #define SPI_STC_vect			_VECTOR(8)
 #define SIG_SPI				_VECTOR(8)
 
 /* UART, Rx Complete */
+#define UART_RX_num 			9
 #define UART_RX_vect			_VECTOR(9)
 #define SIG_UART_RECV			_VECTOR(9)
 
 /* UART Data Register Empty */
+#define UART_UDRE_num 			10
 #define UART_UDRE_vect			_VECTOR(10)
 #define SIG_UART_DATA			_VECTOR(10)
 
 /* UART, Tx Complete */
+#define UART_TX_num 			11
 #define UART_TX_vect			_VECTOR(11)
 #define SIG_UART_TRANS			_VECTOR(11)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			12
 #define ANA_COMP_vect			_VECTOR(12)
 #define SIG_COMPARATOR			_VECTOR(12)
 
@@ -483,4 +496,161 @@
 #define SIGNATURE_2 0x01
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_WR  	DDRD
+#define PORT_WR 	PORTD
+#define PIN_WR  	PIND
+#define WR_IDX  	6
+
+#define DDR_RD  	DDRD
+#define PORT_RD 	PORTD
+#define PIN_RD  	PIND
+#define RD_IDX  	7
+
+
 #endif /* _AVR_IO8515_H_ */
Index: include/avr/io90pwm316.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io90pwm316.h,v
retrieving revision 1.15
diff -u -r1.15 io90pwm316.h
--- include/avr/io90pwm316.h	11 Feb 2009 17:53:35 -0000	1.15
+++ include/avr/io90pwm316.h	26 Mar 2009 20:10:23 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2007, Atmel Corporation
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -1076,87 +1077,115 @@
 /* Interrupt 0 is the reset vector. */
 
 /* PSC2 Capture Event */
+#define PSC2_CAPT_num      1
 #define PSC2_CAPT_vect     _VECTOR(1)
 
 /* PSC2 End Cycle */
+#define PSC2_EC_num        2
 #define PSC2_EC_vect       _VECTOR(2)
 
 /* PSC1 Capture Event */
+#define PSC1_CAPT_num      3
 #define PSC1_CAPT_vect     _VECTOR(3)
 
 /* PSC1 End Cycle */
+#define PSC1_EC_num        4
 #define PSC1_EC_vect       _VECTOR(4)
 
 /* PSC0 Capture Event */
+#define PSC0_CAPT_num      5
 #define PSC0_CAPT_vect     _VECTOR(5)
 
 /* PSC0 End Cycle */
+#define PSC0_EC_num        6
 #define PSC0_EC_vect       _VECTOR(6)
 
 /* Analog Comparator 0 */
+#define ANALOG_COMP_0_num  7
 #define ANALOG_COMP_0_vect _VECTOR(7)
 
 /* Analog Comparator 1 */
+#define ANALOG_COMP_1_num  8
 #define ANALOG_COMP_1_vect _VECTOR(8)
 
 /* Analog Comparator 2 */
+#define ANALOG_COMP_2_num  9
 #define ANALOG_COMP_2_vect _VECTOR(9)
 
 /* External Interrupt Request 0 */
+#define INT0_num           10
 #define INT0_vect          _VECTOR(10)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num    11
 #define TIMER1_CAPT_vect   _VECTOR(11)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num   12
 #define TIMER1_COMPA_vect  _VECTOR(12)
 
 /* Timer/Counter Compare Match B */
+#define TIMER1_COMPB_num   13
 #define TIMER1_COMPB_vect  _VECTOR(13)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num     15
 #define TIMER1_OVF_vect    _VECTOR(15)
 
 /* Timer/Counter0 Compare Match A */
+#define TIMER0_COMP_A_num  16
 #define TIMER0_COMP_A_vect _VECTOR(16)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num     17
 #define TIMER0_OVF_vect    _VECTOR(17)
 
 /* ADC Conversion Complete */
+#define ADC_num            18
 #define ADC_vect           _VECTOR(18)
 
 /* External Interrupt Request 1 */
+#define INT1_num           19
 #define INT1_vect          _VECTOR(19)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num        20
 #define SPI_STC_vect       _VECTOR(20)
 
 /* USART, Rx Complete */
+#define USART_RX_num       21
 #define USART_RX_vect      _VECTOR(21)
 
 /* USART Data Register Empty */
+#define USART_UDRE_num     22
 #define USART_UDRE_vect    _VECTOR(22)
 
 /* USART, Tx Complete */
+#define USART_TX_num       23
 #define USART_TX_vect      _VECTOR(23)
 
 /* External Interrupt Request 2 */
+#define INT2_num           24
 #define INT2_vect          _VECTOR(24)
 
 /* Watchdog Timeout Interrupt */
+#define WDT_num            25
 #define WDT_vect           _VECTOR(25)
 
 /* EEPROM Ready */
+#define EE_READY_num       26
 #define EE_READY_vect      _VECTOR(26)
 
 /* Timer Counter 0 Compare Match B */
+#define TIMER0_COMPB_num   27
 #define TIMER0_COMPB_vect  _VECTOR(27)
 
 /* External Interrupt Request 3 */
+#define INT3_num           28
 #define INT3_vect          _VECTOR(28)
 
 /* Store Program Memory Read */
+#define SPM_READY_num      31
 #define SPM_READY_vect     _VECTOR(31)
 
 #define _VECTORS_SIZE   (4 * 32)
@@ -1221,4 +1250,296 @@
 #define SIGNATURE_2 0x83
 
 
+/* Device Pin Definitions */
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	0
+
+#define DDR_PSCOUT20  	DDRB
+#define PORT_PSCOUT20 	PORTB
+#define PIN_PSCOUT20  	PINB
+#define PSCOUT20_IDX  	0
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	1
+
+#define DDR_PSCOUT21  	DDRB
+#define PORT_PSCOUT21 	PORTB
+#define PIN_PSCOUT21  	PINB
+#define PSCOUT21_IDX  	1
+
+#define DDR_ADC5  	DDRB
+#define PORT_ADC5 	PORTB
+#define PIN_ADC5  	PINB
+#define ADC5_IDX  	2
+
+#define DDR_INT1  	DDRB
+#define PORT_INT1 	PORTB
+#define PIN_INT1  	PINB
+#define INT1_IDX  	2
+
+#define DDR_AMP0_N  	DDRB
+#define PORT_AMP0_N 	PORTB
+#define PIN_AMP0_N  	PINB
+#define AMP0_N_IDX  	3
+
+#define DDR_AMP0_P  	DDRB
+#define PORT_AMP0_P 	PORTB
+#define PIN_AMP0_P  	PINB
+#define AMP0_P_IDX  	4
+
+#define DDR_ADC6  	DDRB
+#define PORT_ADC6 	PORTB
+#define PIN_ADC6  	PINB
+#define ADC6_IDX  	5
+
+#define DDR_INT2  	DDRB
+#define PORT_INT2 	PORTB
+#define PIN_INT2  	PINB
+#define INT2_IDX  	5
+
+#define DDR_ADC7  	DDRB
+#define PORT_ADC7 	PORTB
+#define PIN_ADC7  	PINB
+#define ADC7_IDX  	6
+
+#define DDR_PSCOUT11  	DDRB
+#define PORT_PSCOUT11 	PORTB
+#define PIN_PSCOUT11  	PINB
+#define PSCOUT11_IDX  	6
+
+#define DDR_ICP1B  	DDRB
+#define PORT_ICP1B 	PORTB
+#define PIN_ICP1B  	PINB
+#define ICP1B_IDX  	6
+
+#define DDR_ADC4  	DDRB
+#define PORT_ADC4 	PORTB
+#define PIN_ADC4  	PINB
+#define ADC4_IDX  	7
+
+#define DDR_PSCOUT01  	DDRB
+#define PORT_PSCOUT01 	PORTB
+#define PIN_PSCOUT01  	PINB
+#define PSCOUT01_IDX  	7
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_INT3  	DDRC
+#define PORT_INT3 	PORTC
+#define PIN_INT3  	PINC
+#define INT3_IDX  	0
+
+#define DDR_PSCOUT10  	DDRC
+#define PORT_PSCOUT10 	PORTC
+#define PIN_PSCOUT10  	PINC
+#define PSCOUT10_IDX  	0
+
+#define DDR_PSCIN1  	DDRC
+#define PORT_PSCIN1 	PORTC
+#define PIN_PSCIN1  	PINC
+#define PSCIN1_IDX  	1
+
+#define DDR_OC1B  	DDRC
+#define PORT_OC1B 	PORTC
+#define PIN_OC1B  	PINC
+#define OC1B_IDX  	1
+
+#define DDR_T0  	DDRC
+#define PORT_T0 	PORTC
+#define PIN_T0  	PINC
+#define T0_IDX  	2
+
+#define DDR_PSCOUT22  	DDRC
+#define PORT_PSCOUT22 	PORTC
+#define PIN_PSCOUT22  	PINC
+#define PSCOUT22_IDX  	2
+
+#define DDR_T1  	DDRC
+#define PORT_T1 	PORTC
+#define PIN_T1  	PINC
+#define T1_IDX  	3
+
+#define DDR_PSCOUT23  	DDRC
+#define PORT_PSCOUT23 	PORTC
+#define PIN_PSCOUT23  	PINC
+#define PSCOUT23_IDX  	3
+
+#define DDR_ADC8  	DDRC
+#define PORT_ADC8 	PORTC
+#define PIN_ADC8  	PINC
+#define ADC8_IDX  	4
+
+#define DDR_AMP1_N  	DDRC
+#define PORT_AMP1_N 	PORTC
+#define PIN_AMP1_N  	PINC
+#define AMP1_N_IDX  	4
+
+#define DDR_ADC9  	DDRC
+#define PORT_ADC9 	PORTC
+#define PIN_ADC9  	PINC
+#define ADC9_IDX  	5
+
+#define DDR_AMP1_P  	DDRC
+#define PORT_AMP1_P 	PORTC
+#define PIN_AMP1_P  	PINC
+#define AMP1_P_IDX  	5
+
+#define DDR_ADC10  	DDRC
+#define PORT_ADC10 	PORTC
+#define PIN_ADC10  	PINC
+#define ADC10_IDX  	6
+
+#define DDR_ACMP1  	DDRC
+#define PORT_ACMP1 	PORTC
+#define PIN_ACMP1  	PINC
+#define ACMP1_IDX  	6
+
+#define DDR_D2A  	DDRC
+#define PORT_D2A 	PORTC
+#define PIN_D2A  	PINC
+#define D2A_IDX  	7
+
+#define DDR_PSCOUT00  	DDRD
+#define PORT_PSCOUT00 	PORTD
+#define PIN_PSCOUT00  	PIND
+#define PSCOUT00_IDX  	0
+
+#define DDR_XCK  	DDRD
+#define PORT_XCK 	PORTD
+#define PIN_XCK  	PIND
+#define XCK_IDX  	0
+
+#define DDR_SSA  	DDRD
+#define PORT_SSA 	PORTD
+#define PIN_SSA  	PIND
+#define SSA_IDX  	0
+
+#define DDR_PSCIN0  	DDRD
+#define PORT_PSCIN0 	PORTD
+#define PIN_PSCIN0  	PIND
+#define PSCIN0_IDX  	1
+
+#define DDR_CLKO  	DDRD
+#define PORT_CLKO 	PORTD
+#define PIN_CLKO  	PIND
+#define CLKO_IDX  	1
+
+#define DDR_PSCIN2  	DDRD
+#define PORT_PSCIN2 	PORTD
+#define PIN_PSCIN2  	PIND
+#define PSCIN2_IDX  	2
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	2
+
+#define DDR_MISO_A  	DDRD
+#define PORT_MISO_A 	PORTD
+#define PIN_MISO_A  	PIND
+#define MISO_A_IDX  	2
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	3
+
+#define DDR_DALI  	DDRD
+#define PORT_DALI 	PORTD
+#define PIN_DALI  	PIND
+#define DALI_IDX  	3
+
+#define DDR_OC0A  	DDRD
+#define PORT_OC0A 	PORTD
+#define PIN_OC0A  	PIND
+#define OC0A_IDX  	3
+
+#define DDR_SS  	DDRD
+#define PORT_SS 	PORTD
+#define PIN_SS  	PIND
+#define SS_IDX  	3
+
+#define DDR_MOSI_A  	DDRD
+#define PORT_MOSI_A 	PORTD
+#define PIN_MOSI_A  	PIND
+#define MOSI_A_IDX  	3
+
+#define DDR_ADC1  	DDRD
+#define PORT_ADC1 	PORTD
+#define PIN_ADC1  	PIND
+#define ADC1_IDX  	4
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	4
+
+#define DDR_DALI  	DDRD
+#define PORT_DALI 	PORTD
+#define PIN_DALI  	PIND
+#define DALI_IDX  	4
+
+#define DDR_ICP1  	DDRD
+#define PORT_ICP1 	PORTD
+#define PIN_ICP1  	PIND
+#define ICP1_IDX  	4
+
+#define DDR_SCK_A  	DDRD
+#define PORT_SCK_A 	PORTD
+#define PIN_SCK_A  	PIND
+#define SCK_A_IDX  	4
+
+#define DDR_ADC2  	DDRD
+#define PORT_ADC2 	PORTD
+#define PIN_ADC2  	PIND
+#define ADC2_IDX  	5
+
+#define DDR_ACOMP2  	DDRD
+#define PORT_ACOMP2 	PORTD
+#define PIN_ACOMP2  	PIND
+#define ACOMP2_IDX  	5
+
+#define DDR_ADC3  	DDRD
+#define PORT_ADC3 	PORTD
+#define PIN_ADC3  	PIND
+#define ADC3_IDX  	6
+
+#define DDR_ACMPM  	DDRD
+#define PORT_ACMPM 	PORTD
+#define PIN_ACMPM  	PIND
+#define ACMPM_IDX  	6
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	6
+
+#define DDR_ACMP0  	DDRD
+#define PORT_ACMP0 	PORTD
+#define PIN_ACMP0  	PIND
+#define ACMP0_IDX  	7
+
+#define DDR_OCD  	DDRE
+#define PORT_OCD 	PORTE
+#define PIN_OCD  	PINE
+#define OCD_IDX  	0
+
+#define DDR_OC0B  	DDRE
+#define PORT_OC0B 	PORTE
+#define PIN_OC0B  	PINE
+#define OC0B_IDX  	1
+
+#define DDR_ADC0  	DDRE
+#define PORT_ADC0 	PORTE
+#define PIN_ADC0  	PINE
+#define ADC0_IDX  	2
+
+
 #endif /* _AVR_IO90PWM316_H_ */
Index: include/avr/iom161.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom161.h,v
retrieving revision 1.15
diff -u -r1.15 iom161.h
--- include/avr/iom161.h	17 Oct 2008 23:22:42 -0000	1.15
+++ include/avr/iom161.h	26 Mar 2009 20:10:27 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -228,82 +229,102 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		4
 #define TIMER2_COMP_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(4)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			5
 #define TIMER2_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW2			_VECTOR(5)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		6
 #define TIMER1_CAPT_vect		_VECTOR(6)
 #define SIG_INPUT_CAPTURE1		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		7
 #define TIMER1_COMPA_vect		_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(7)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		8
 #define TIMER1_COMPB_vect		_VECTOR(8)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(8)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			9
 #define TIMER1_OVF_vect			_VECTOR(9)
 #define SIG_OVERFLOW1			_VECTOR(9)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		10
 #define TIMER0_COMP_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(10)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			11
 #define TIMER0_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW0			_VECTOR(11)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			12
 #define SPI_STC_vect			_VECTOR(12)
 #define SIG_SPI				_VECTOR(12)
 
 /* UART0, Rx Complete */
+#define UART0_RX_num 			13
 #define UART0_RX_vect			_VECTOR(13)
 #define SIG_UART0_RECV			_VECTOR(13)
 
 /* UART1, Rx Complete */
+#define UART1_RX_num 			14
 #define UART1_RX_vect			_VECTOR(14)
 #define SIG_UART1_RECV			_VECTOR(14)
 
 /* UART0 Data Register Empty */
+#define UART0_UDRE_num 			15
 #define UART0_UDRE_vect			_VECTOR(15)
 #define SIG_UART0_DATA			_VECTOR(15)
 
 /* UART1 Data Register Empty */
+#define UART1_UDRE_num 			16
 #define UART1_UDRE_vect			_VECTOR(16)
 #define SIG_UART1_DATA			_VECTOR(16)
 
 /* UART0, Tx Complete */
+#define UART0_TX_num 			17
 #define UART0_TX_vect			_VECTOR(17)
 #define SIG_UART0_TRANS			_VECTOR(17)
 
 /* UART1, Tx Complete */
+#define UART1_TX_num 			18
 #define UART1_TX_vect			_VECTOR(18)
 #define SIG_UART1_TRANS			_VECTOR(18)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			19
 #define EE_RDY_vect			_VECTOR(19)
 #define SIG_EEPROM_READY		_VECTOR(19)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			20
 #define ANA_COMP_vect			_VECTOR(20)
 #define SIG_COMPARATOR			_VECTOR(20)
 
@@ -670,4 +691,186 @@
 #define SIGNATURE_2 0x01
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_OC0/T0  	DDRB
+#define PORT_OC0/T0 	PORTB
+#define PIN_OC0/T0  	PINB
+#define OC0/T0_IDX  	0
+
+#define DDR_OC2/T1  	DDRB
+#define PORT_OC2/T1 	PORTB
+#define PIN_OC2/T1  	PINB
+#define OC2/T1_IDX  	1
+
+#define DDR_RXD1  	DDRB
+#define PORT_RXD1 	PORTB
+#define PIN_RXD1  	PINB
+#define RXD1_IDX  	2
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_TXD1  	DDRB
+#define PORT_TXD1 	PORTB
+#define PIN_TXD1  	PINB
+#define TXD1_IDX  	3
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_WR  	DDRD
+#define PORT_WR 	PORTD
+#define PIN_WR  	PIND
+#define WR_IDX  	6
+
+#define DDR_RD  	DDRD
+#define PORT_RD 	PORTD
+#define PIN_RD  	PIND
+#define RD_IDX  	7
+
+#define DDR_ICP/INT2  	DDRE
+#define PORT_ICP/INT2 	PORTE
+#define PIN_ICP/INT2  	PINE
+#define ICP/INT2_IDX  	0
+
+#define DDR_ALE  	DDRE
+#define PORT_ALE 	PORTE
+#define PIN_ALE  	PINE
+#define ALE_IDX  	1
+
+#define DDR_OC1B  	DDRE
+#define PORT_OC1B 	PORTE
+#define PIN_OC1B  	PINE
+#define OC1B_IDX  	2
+
+
 #endif /* _AVR_IOM161_H_ */
Index: include/avr/iotn15.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotn15.h,v
retrieving revision 1.17
diff -u -r1.17 iotn15.h
--- include/avr/iotn15.h	17 Oct 2008 23:22:44 -0000	1.17
+++ include/avr/iotn15.h	26 Mar 2009 20:10:35 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002,2005 Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -139,35 +140,43 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 0 */
+#define IO_PINS_num 			2
 #define IO_PINS_vect			_VECTOR(2)
 #define SIG_PIN				_VECTOR(2)
 #define SIG_PIN_CHANGE			_VECTOR(2)
 
 /* Timer/Counter1 Compare Match */
+#define TIMER1_COMP_num 		3
 #define TIMER1_COMP_vect		_VECTOR(3)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(3)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			4
 #define TIMER1_OVF_vect			_VECTOR(4)
 #define SIG_OVERFLOW1			_VECTOR(4)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			5
 #define TIMER0_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW0			_VECTOR(5)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			6
 #define EE_RDY_vect			_VECTOR(6)
 #define SIG_EEPROM_READY		_VECTOR(6)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			7
 #define ANA_COMP_vect			_VECTOR(7)
 #define SIG_COMPARATOR			_VECTOR(7)
 
 /* ADC Conversion Ready */
+#define ADC_num 			8
 #define ADC_vect			_VECTOR(8)
 #define SIG_ADC				_VECTOR(8)
 
@@ -330,4 +339,66 @@
 #define SIGNATURE_2 0x06
 
 
+/* Device Pin Definitions */
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	0
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	0
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	1
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	1
+
+#define DDR_OCP  	DDRB
+#define PORT_OCP 	PORTB
+#define PIN_OCP  	PINB
+#define OCP_IDX  	1
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	2
+
+#define DDR_ADC1  	DDRB
+#define PORT_ADC1 	PORTB
+#define PIN_ADC1  	PINB
+#define ADC1_IDX  	2
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	2
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	2
+
+#define DDR_ADC2  	DDRB
+#define PORT_ADC2 	PORTB
+#define PIN_ADC2  	PINB
+#define ADC2_IDX  	3
+
+#define DDR_ADC3  	DDRB
+#define PORT_ADC3 	PORTB
+#define PIN_ADC3  	PINB
+#define ADC3_IDX  	4
+
+#define DDR_ADC0  	DDRB
+#define PORT_ADC0 	PORTB
+#define PIN_ADC0  	PINB
+#define ADC0_IDX  	5
+
+
 #endif /* _AVR_IOTN15_H_ */
